#ifndef EFL_GENERATED_EFL_CONTROL_HH
#define EFL_GENERATED_EFL_CONTROL_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "efl_control.eo.h"
}


namespace efl {

struct control;

}

namespace eo_cxx {

namespace efl {

struct control
{
   /// @param priority The priority of the object
   ///
   int priority_get() const;


   /// @param priority The priority of the object
   ///
   void priority_set(int priority_) const;


   /// @param suspend Controls whether the object is suspended or not.
   ///
   bool suspend_get() const;


   /// @param suspend Controls whether the object is suspended or not.
   ///
   void suspend_set(bool suspend_) const;



   static Eo_Class const* _eo_class()
   {
      return(EFL_CONTROL_INTERFACE);
   }

   operator ::efl::control() const;
   operator ::efl::control&();
   operator ::efl::control const&() const;

   template <typename D>
   struct address_of
   {
      operator ::efl::control*() const { return static_cast<::efl::control*>(static_cast<D const*>(this)->p); }
      operator ::efl::control const*() const { return static_cast<::efl::control const*>(static_cast<D const*>(this)->p); }
   };

   template <typename D>
   struct address_const_of
   {
      operator ::efl::control const*() const { return static_cast<::efl::control const*>(static_cast<D const*>(this)->p); }
   };

private:
   Eo* _concrete_eo_ptr() const
   {
      return static_cast<::efl::eo::concrete const*>(static_cast<void const*>(this))->_eo_ptr();
   }

};

}

}

namespace efl {

struct control
      : ::efl::eo::concrete
{
   control(::efl::eo::parent_type _p = (::efl::eo::parent = nullptr))
      : control(_ctors_call(_p))
   {}

   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit control(Eo* eo)
      : ::efl::eo::concrete(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit control(std::nullptr_t)
      : ::efl::eo::concrete(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   control(control const& other)
      : control(eo_ref(other._eo_ptr()))
   {}

   ~control() {}

   /// @param priority The priority of the object
   ///
   int priority_get() const;


   /// @param priority The priority of the object
   ///
   void priority_set(int priority_) const;


   /// @param suspend Controls whether the object is suspended or not.
   ///
   bool suspend_get() const;


   /// @param suspend Controls whether the object is suspended or not.
   ///
   void suspend_set(bool suspend_) const;



   static Eo_Class const* _eo_class()
   {
      return(EFL_CONTROL_INTERFACE);
   }

   struct address_of
      : ::eo_cxx::efl::control::address_of<address_of>
      , ::efl::eo::detail::concrete_address_of
   {
      explicit address_of(::efl::control* p)
         : ::efl::eo::detail::concrete_address_of(p)
      {}
   };
   address_of operator&() { return address_of(this); }

   struct address_const_of
      : ::eo_cxx::efl::control::address_const_of<address_const_of>
      , ::efl::eo::detail::concrete_address_const_of
   {
      explicit address_const_of(::efl::control const* p)
         : ::efl::eo::detail::concrete_address_const_of(p)
      {}
   };
   address_const_of operator&() const { return address_const_of(this); }

private:
   static Eo* _ctors_call(::efl::eo::parent_type _p)
   {
      Eo* _ret_eo = eo_add_ref(EFL_CONTROL_INTERFACE, _p._eo_raw, );

      return _ret_eo;
   }

      Eo* _concrete_eo_ptr() const { return _eo_ptr(); }
};

static_assert(sizeof(::efl::control) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<::efl::control>::value, "");

}

inline int efl::control::priority_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::efl_control_priority_get());
   return _tmp_ret;
}


inline void efl::control::priority_set(int priority_) const
{
   eo_do(_concrete_eo_ptr(), ::efl_control_priority_set(priority_));
}


inline bool efl::control::suspend_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::efl_control_suspend_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}


inline void efl::control::suspend_set(bool suspend_) const
{
   eo_do(_concrete_eo_ptr(), ::efl_control_suspend_set(::efl::eolian::to_c(suspend_)));
}


inline int eo_cxx::efl::control::priority_get() const
{
   int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::efl_control_priority_get());
   return _tmp_ret;
}


inline void eo_cxx::efl::control::priority_set(int priority_) const
{
   eo_do(_concrete_eo_ptr(), ::efl_control_priority_set(priority_));
}


inline bool eo_cxx::efl::control::suspend_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::efl_control_suspend_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}


inline void eo_cxx::efl::control::suspend_set(bool suspend_) const
{
   eo_do(_concrete_eo_ptr(), ::efl_control_suspend_set(::efl::eolian::to_c(suspend_)));
}


inline ::eo_cxx::efl::control::operator ::efl::control() const
{
   return *static_cast<::efl::control const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::efl::control::operator ::efl::control&()
{
   return *static_cast<::efl::control*>(static_cast<void*>(this));
}

inline ::eo_cxx::efl::control::operator ::efl::control const&() const
{
   return *static_cast<::efl::control const*>(static_cast<void const*>(this));
}

template <typename T>
int efl_control_priority_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   int _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->priority_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void efl_control_priority_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, int priority_)
{
   try
      {
         static_cast<T*>(self->this_)->priority_set(priority_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool efl_control_suspend_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   bool _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->suspend_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void efl_control_suspend_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool suspend_)
{
   try
      {
         static_cast<T*>(self->this_)->suspend_set(::efl::eolian::to_cxx<bool>(suspend_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::efl::control >
{
   template <typename T>
   struct type
   {
      virtual int priority_get()
      {
         int _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::efl_control_priority_get());
            return _tmp_ret;
      }

      virtual void priority_set(int priority_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::efl_control_priority_set(priority_));
      }

      virtual bool suspend_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::efl_control_suspend_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void suspend_set(bool suspend_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::efl_control_suspend_set(::efl::eolian::to_c(suspend_)));
      }

   };
};


template<>
struct operation_description_class_size< ::efl::control >
{
   static const int value = 4;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::efl::control>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::efl_control_priority_get_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::efl_control_priority_get);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::efl_control_priority_set_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::efl_control_priority_set);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::efl_control_suspend_get_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::efl_control_suspend_get);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::efl_control_suspend_set_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::efl_control_suspend_set);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   return 0;
}
inline void
call_constructor(::efl::eo::detail::tag< ::efl::control >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               ::efl::eo::detail::args_class<::efl::control, ::std::tuple<::efl::eo::parent_type> > const& args)
{
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

inline Eo_Class const* get_eo_class(tag<::efl::control>)
{
   return (EFL_CONTROL_INTERFACE);
}

} } }
#endif // EFL_GENERATED_EFL_CONTROL_HH

